package com.bzd.web.controller.jkgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.jkgl.SJkglRegistrationinfoService;

import java.util.List;

/**
*
* 购药信息收集 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "jkgl/sjkglregistrationinfo")
public class SJkglRegistrationinfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "jkgl";

    @Autowired
    private SJkglRegistrationinfoService sJkglRegistrationinfoService;

    /**
    * 购药信息收集 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("jkgl:jk:view")
    @GetMapping("/sJkglRegistrationinfoAdd")
    public String add() {
        return prefix + "/SJkglRegistrationinfoAdd";
    }

    /**
    * 购药信息收集 新增
    *
    * @return
    */
    @Log(title = "购药信息收集新增", businessType = BusinessType.INSERT)
    @PostMapping("/sJkglRegistrationinfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sJkglRegistrationinfoService.addSJkglRegistrationinfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 购药信息收集 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("jkgl:jk:view")
    @GetMapping("/sJkglRegistrationinfoView")
    public String sjkglregistrationinfoListView() {
        return prefix + "/SJkglRegistrationinfoList";
    }

    /**
    * 购药信息收集 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("jkgl:jk:sJkglRegistrationinfoList")
    @PostMapping("/sJkglRegistrationinfoList")
    @ResponseBody
    public TableDataInfo sjkglregistrationinfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sJkglRegistrationinfoService.findSJkglRegistrationinfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 购药信息收集 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("jkgl:jk:remove")
    @Log(title = "购药信息收集删除", businessType = BusinessType.DELETE)
    @PostMapping("/sJkglRegistrationinfoRemove")
    @ResponseBody
    public AjaxResult sjkglregistrationinfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sJkglRegistrationinfoService.SJkglRegistrationinfoRemove(pd);
        return toAjax(integer);
    }

    /**
    * 购药信息收集 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("jkgl:jk:edit")
    @GetMapping("/sJkglRegistrationinfoEdit/{id}")
    public String sjkglregistrationinfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sJkglRegistrationinfoService.findSJkglRegistrationinfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sjkglregistrationinfoPageEdit";
        }
        return prefix+ "/sjkglregistrationinfoEdit";
    }

    /**
    * 购药信息收集保存修改的数据
    */
    @RequiresPermissions("jkgl:jk:edit")
    @Log(title = "购药信息收集修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sJkglRegistrationinfoEdit")
    @ResponseBody
    public AjaxResult sjkglregistrationinfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sJkglRegistrationinfoService.updateSJkglRegistrationinfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sjkglregistrationinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sjkglregistrationinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
